#include <avr/io.h>
#include <avr/interrupt.h> 
#include <util/delay.h>   
#include <avr/pgmspace.h>
#include <stdio.h>  
#include "usbdrv/usbdrv.c"
#include "usbdrv/requests.h" 
#include "therm_ds18b20.h"

#define usb_init_all usbInit(); usbDeviceDisconnect(); _delay_ms(250); usbDeviceConnect();

#define sbi(reg,bit) reg |= (1<<bit)
#define cbi(reg,bit) reg &= ~(1<<bit)
#define ibi(reg,bit) reg ^= (1<<bit)

//static uchar 	  rxbuffer[128];
//static uchar      txbuffer[128]; 

volatile uchar    currentAddress;
volatile uchar    bytesRemaining;

#define RQ_TYPE_read_themperature  0x05

unsigned char temperatureds[3] = {'N',0,0};

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
  	usbRequest_t *rq = (void *)data;
//  	unsigned char  addr = rq->wIndex.bytes[0]; 
//  	unsigned char val = rq->wValue.bytes[0]; 

  	switch(rq->bRequest)
  	{
  		case RQ_TYPE_read_themperature: 
    			usbMsgPtr = temperatureds;
    			return sizeof(temperatureds);
  	}	
  	return 0;  
}
/*
uchar usbFunctionWrite(uchar *data, uchar len)
{
    uchar i;
    if(len > bytesRemaining) len = bytesRemaining;				
    bytesRemaining -= len;											
    for(i = 0; i < len; i++) 
	{
		rxbuffer[currentAddress++] = data[i];
	}
    return bytesRemaining == 0;
}*/

int main(void)
{
	DDRB = 0b00000000; PORTB = 0b00000000;
	DDRC = 0b00010000; PORTC = 0b00000000;
	DDRD = 0b00000000; PORTD = 0b00000000;

	usb_init_all;
    sei();
    while(1)
	{
	usbPoll();
		ibi(PORTC,4);
		therm_read_temperature(temperatureds, 0);
    usbPoll();
    }
}
